
#include "StdAfx.h"
#include "WASCheckUpNotice.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"
#include "GTCommonAPI.h"

CWASCheckUpNotice::CWASCheckUpNotice(CWASActor *pActor) : CWASCommand(pActor)
{
    m_strServiceID = NULL;
    m_nErrorCode = 0;
}

CWASCheckUpNotice::~CWASCheckUpNotice(void)
{
}

void CWASCheckUpNotice::ExecuteAsync()
{
	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	m_eError = wasError_None;
	USES_UTF8_CONVERSION;

	const char* chServieceID		= "serviceId";
	m_strServiceID = _T("msn_pc");
	m_bNewNotice =FALSE;

	// İ IP:Ʈ   ҰϿ Ŭܿ ּҸ ´.
	std::stringstream strStream;
	strStream << W2U8(m_strURL.c_str());
	strStream << "?serviceId=msn_pc"; 

	m_httpFacade.session().SetURL( strStream.str().c_str(), NULL, HTTP_SERVICE_HTTP);
	m_httpFacade.session().SetMethod(HTTP_METHOD_GET);

	//m_httpFacade.session().SetURL( W2U8(m_strURL.c_str()));
	//m_httpFacade.session().SetMethod(HTTP_METHOD_POST);
	//m_httpFacade.session().AddBodyVariable("serviceId", W2U8(m_strServiceID));


	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);

}

bool CWASCheckUpNotice::ParseAndEventFire( Json::Value * json )
{
	m_bNewNotice = true;
	Json::Reader reader;
	std::string strJsonResult = json->get("returnMessage","").asString();
	m_nErrorCode = atoi(json->get("returnCode", "-1").asString().c_str());
	int nNoticeCount = (*json)["returnValue"].get("changeNoticeCount","0").asInt();
	if (nNoticeCount <= 0)
	{
		m_bNewNotice = false;
		return true;
	}
	if (strJsonResult != "OK")
	{
		::OutputDebugString(L"JSON Result is NOT OK\n");
		//OK ƴҰ  ޽ ޴´.
		m_strResponseMsg = Conversion::Utf8ToWide(json->get("returnMessage","").asString());
		::OutputDebugString(m_strResponseMsg.c_str());
		m_nErrorCode = atoi(json->get("returnCode", "").asString().c_str());
		return false;
	}

	m_checkUpNotice.nChangeNoticeSeq = (*json)["returnValue"]["changeNotice"].get("changeNoticeSeq","-1").asInt();	

	m_checkUpNotice.strChekReason = Conversion::Utf8ToWide((*json)["returnValue"]["changeNotice"].get("checkReason" , "").asString());	

	
	m_checkUpNotice.strChangeTypeCode = Conversion::Utf8ToWide((*json)["returnValue"]["changeNotice"].get("changeTypeCode" , "").asString());	
	const Json::Value CycleCdListJson = (*json)["returnValue"]["changeNotice"]["exposureCycleCd"];
	

	m_checkUpNotice.strCheckStartYMDT = Conversion::Utf8ToWide((*json)["returnValue"]["changeNotice"].get("chckStrtYmdtString","").asString());	
	m_checkUpNotice.strCheckEndYMDT = Conversion::Utf8ToWide((*json)["returnValue"]["changeNotice"].get("chckEndYmdtString","").asString());	

	return true;

}


void CWASCheckUpNotice::OnWasResponse( trid_t trid, bool bSuccess, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, LPCSTR /*szWasResCodeInHeader*/, LPCSTR /*szWasResCodeInXml*/, Json::Value * json )
{

	if(bSuccess)
	{
		if(ParseAndEventFire(json) == false)
			m_eError = wasError_Protocol;
	}
	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();
	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseCheckUpNotice(m_pActor, GetID(), m_eError,  m_checkUpNotice, m_nErrorCode, m_strResponseMsg.c_str(), m_bNewNotice) == false)
			break;
	}
	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());

}

void CWASCheckUpNotice::OnRequestTimeout( CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/ )
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseCheckUpNotice(m_pActor, GetID(), m_eError,  m_checkUpNotice, m_nErrorCode, m_strResponseMsg.c_str(), m_bNewNotice) == false)
			break;
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
